/*
// File:		SmtpCallback.cpp
//
// Version:		mail.it library 1.0
//
// Copyright:	(C) 2007 Dacons LLP.
//
// Bugs:		If you have problems or suggestions, please contact
//				the Online Support at: http://www.dacons.net/support
*/

#include PCH_FILE_NAME
#include "SmtpCallback.h"

EmaiError
SmtpCallback::OnOperation(
		Emai::SmtpSession& inSession,
		EmaiUint32 inOperationCode
	)
{
	EmaiUint32 statSize = sizeof(NSTextField*);
	NSTextField* status = NULL;
	inSession.GetUserData(SmtpStatusText, &status, statSize);
	NSString* statusTexts[] = {
		@"Connecting to server...",
		@"Successfully connected to server.",
		@"Authenticating on server...",
		@"Successfully authenticated on server.",
		@"Introducing sender...",
		@"Successfully introduced sender.",
		@"Sending recipients...",
		@"Recipients successfully sent.",
		@"Sending message data...",
		@"Message data successfully sent.",
		@"Sending NOOP...",
		@"NOOP successfully sent.",
		@"Closing connection.",
		@"Connection successfully closed."	
	};
		
	[status setStringValue:statusTexts[inOperationCode]];
	[status displayIfNeeded];
	return EmaiErrNoErr;
}

EmaiError
SmtpCallback::OnDataSent(
		Emai::SmtpSession& inSession,
		EmaiUint32 inSentSize,
		EmaiUint32 inTotalSize
	)
{
	EmaiUint32 fieldSize = sizeof(NSTextField*);
	int percent = 0;
	int curPercent = (100 * inSentSize) / inTotalSize;
	EmaiUint32 numSize = sizeof(EmaiUint32);
	inSession.GetUserData(SmtpCurrentPercent, &percent, numSize);
	if (percent != curPercent)
	{
		NSTextField* status = NULL;
		inSession.GetUserData(SmtpPercentText, &status, fieldSize);
		[status setStringValue:[NSString stringWithFormat: @"%d %%", curPercent]];
		[status displayIfNeeded];
		inSession.SetUserData(SmtpCurrentPercent, &curPercent, numSize);
	}	
	return EmaiErrNoErr;
}

EmaiError
SmtpCallback::OnServerError(
		Emai::SmtpSession& inSession,
		EmaiConstCharPtr inServerReply,
		EmaiUint32 /*inReplyCode*/
	)
{
	NSTextField* status = NULL;
	EmaiUint32 fieldSize = sizeof(NSTextField*);
	inSession.GetUserData(SmtpStatusText, &status, fieldSize);
	[status setStringValue:[NSString stringWithFormat: @"The server error encountered was: %s", inServerReply]];
	[status displayIfNeeded];
	return EmaiErrNoErr;
}
